
package de.ivu.elect.presentation.gebietsbaum;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gebietsbaum.boundary.CommonGebietsgruppierungBoundaryCreate;
import de.ivu.elect.business.gebietsbaum.entity.Gebietsgruppierung;
import de.ivu.elect.business.wahl.boundary.WahlNichtAusgewaehltException;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.gebietsbaum.form.GebietsgruppierungViewFormBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;

@OnlineHilfeId("530")
@Named(GebietsgruppierungCreateView.COMPONENT_NAME)
public class GebietsgruppierungCreateView extends AbstractGebietsgruppierungCreateView {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient GebietsgruppierungViewFormBuilder viewFormBuilder;

  @Inject
  private transient CommonGebietsgruppierungBoundaryCreate create;

  public GebietsgruppierungCreateView() {
    super();
  }

  @PreConditionCheck
  public String checkPreCondition() {
    if (isWahlSelected() || isWahlterminSelected()) {
      return null;
    }

    throw new WahlNichtAusgewaehltException();
  }

  @Override
  @PostConstruct
  public void init() {
    super.init();

    Gebietsgruppierung gebietsgruppierung = getEntity();

    if (isWahlSelected()) {
      Wahl wahl = getSelectedWahl();

      gebietsgruppierung.setWahl(wahl);
      gebietsgruppierung.setWahltermin(wahl.getWahltermin());
    } else {
      gebietsgruppierung.setWahltermin(getSelectedWahltermin());
    }
  }

  @Override
  public void addProperties(FormBuilder formBuilder, Gebietsgruppierung gebietsgruppierung) {
    viewFormBuilder.addProperties(formBuilder, gebietsgruppierung);
  }

  @Override
  protected void callSave(Gebietsgruppierung entity) {
    // ELECT-4674
    create.save(entity, entity.getZugeordneteGebieteFuerCreate());
  }
}
